
registers = {
    'al': ('al', 'r8', '8', 0),
    'cl': ('cl', 'r8', '8', 1),
    'dl': ('dl', 'r8', '8', 2),
    'bl': ('bl', 'r8', '8', 3),
    'ah': ('ah', 'r8', '8', 4),
    'ch': ('ch', 'r8', '8', 5),
    'dh': ('dh', 'r8', '8', 6),
    'bh': ('bh', 'r8', '8', 7),
    'spl': ('spl', 'r8', '8', 4),
    'bpl': ('bpl', 'r8', '8', 5),
    'sil': ('sil', 'r8', '8', 6),
    'dil': ('dil', 'r8', '8', 7),
    'r8l': ('r8l', 'r8', '8', 0),
    'r9l': ('r9l', 'r8', '8', 1),
    'r10l': ('r10l', 'r8', '8', 2),
    'r11l': ('r11l', 'r8', '8', 3),
    'r12l': ('r12l', 'r8', '8', 4),
    'r13l': ('r13l', 'r8', '8', 5),
    'r14l': ('r14l', 'r8', '8', 6),
    'r15l': ('r15l', 'r8', '8', 7),
    'ax': ('ax', 'r16', '16', 0),
    'cx': ('cx', 'r16', '16', 1),
    'dx': ('dx', 'r16', '16', 2),
    'bx': ('bx', 'r16', '16', 3),
    'sp': ('sp', 'r16', '16', 4),
    'bp': ('bp', 'r16', '16', 5),
    'si': ('si', 'r16', '16', 6),
    'di': ('di', 'r16', '16', 7),
    'r8w': ('r8w', 'r16', '16', 0),
    'r9w': ('r9w', 'r16', '16', 1),
    'r10w': ('r10w', 'r16', '16', 2),
    'r11w': ('r11w', 'r16', '16', 3),
    'r12w': ('r12w', 'r16', '16', 4),
    'r13w': ('r13w', 'r16', '16', 5),
    'r14w': ('r14w', 'r16', '16', 6),
    'r15w': ('r15w', 'r16', '16', 7),
    'eax': ('eax', 'r32', '32', 0),
    'ecx': ('ecx', 'r32', '32', 1),
    'edx': ('edx', 'r32', '32', 2),
    'ebx': ('ebx', 'r32', '32', 3),
    'esp': ('esp', 'r32', '32', 4),
    'ebp': ('ebp', 'r32', '32', 5),
    'esi': ('esi', 'r32', '32', 6),
    'edi': ('edi', 'r32', '32', 7),
    'r8d': ('r8d', 'r32', '32', 0),
    'r9d': ('r9d', 'r32', '32', 1),
    'r10d': ('r10d', 'r32', '32', 2),
    'r11d': ('r11d', 'r32', '32', 3),
    'r12d': ('r12d', 'r32', '32', 4),
    'r13d': ('r13d', 'r32', '32', 5),
    'r14d': ('r14d', 'r32', '32', 6),
    'r15d': ('r15d', 'r32', '32', 7),
    'rax': ('rax', 'r64', '64', 0),
    'rcx': ('rcx', 'r64', '64', 1),
    'rdx': ('rdx', 'r64', '64', 2),
    'rbx': ('rbx', 'r64', '64', 3),
    'rsp': ('rsp', 'r64', '64', 4),
    'rbp': ('rbp', 'r64', '64', 5),
    'rsi': ('rsi', 'r64', '64', 6),
    'rdi': ('rdi', 'r64', '64', 7),
    'r8': ('r8', 'r64', '64', 0),
    'r9': ('r9', 'r64', '64', 1),
    'r10': ('r10', 'r64', '64', 2),
    'r11': ('r11', 'r64', '64', 3),
    'r12': ('r12', 'r64', '64', 4),
    'r13': ('r13', 'r64', '64', 5),
    'r14': ('r14', 'r64', '64', 6),
    'r15': ('r15', 'r64', '64', 7),
    'st0': ('st0', 'ST(i)', '80', 0),
    'st1': ('st1', 'ST(i)', '80', 1),
    'st2': ('st2', 'ST(i)', '80', 2),
    'st3': ('st3', 'ST(i)', '80', 3),
    'st4': ('st4', 'ST(i)', '80', 4),
    'st5': ('st5', 'ST(i)', '80', 5),
    'st6': ('st6', 'ST(i)', '80', 6),
    'st7': ('st7', 'ST(i)', '80', 7),
    'mm0': ('mm0', 'mm', '64', 0),
    'mm1': ('mm1', 'mm', '64', 1),
    'mm2': ('mm2', 'mm', '64', 2),
    'mm3': ('mm3', 'mm', '64', 3),
    'mm4': ('mm4', 'mm', '64', 4),
    'mm5': ('mm5', 'mm', '64', 5),
    'mm6': ('mm6', 'mm', '64', 6),
    'mm7': ('mm7', 'mm', '64', 7),
    'xmm0': ('xmm0', 'xmm', '128', 0),
    'xmm1': ('xmm1', 'xmm', '128', 1),
    'xmm2': ('xmm2', 'xmm', '128', 2),
    'xmm3': ('xmm3', 'xmm', '128', 3),
    'xmm4': ('xmm4', 'xmm', '128', 4),
    'xmm5': ('xmm5', 'xmm', '128', 5),
    'xmm6': ('xmm6', 'xmm', '128', 6),
    'xmm7': ('xmm7', 'xmm', '128', 7),
    'xmm8': ('xmm8', 'xmm', '128', 0),
    'xmm9': ('xmm9', 'xmm', '128', 1),
    'xmm10': ('xmm10', 'xmm', '128', 2),
    'xmm11': ('xmm11', 'xmm', '128', 3),
    'xmm12': ('xmm12', 'xmm', '128', 4),
    'xmm13': ('xmm13', 'xmm', '128', 5),
    'xmm14': ('xmm14', 'xmm', '128', 6),
    'xmm15': ('xmm15', 'xmm', '128', 7),

    'ymm0': ('ymm0', 'ymm', '256', 0),
    'ymm1': ('ymm1', 'ymm', '256', 1),
    'ymm2': ('ymm2', 'ymm', '256', 2),
    'ymm3': ('ymm3', 'ymm', '256', 3),
    'ymm4': ('ymm4', 'ymm', '256', 4),
    'ymm5': ('ymm5', 'ymm', '256', 5),
    'ymm6': ('ymm6', 'ymm', '256', 6),
    'ymm7': ('ymm7', 'ymm', '256', 7),
    'ymm8': ('ymm8', 'ymm', '256', 0),
    'ymm9': ('ymm9', 'ymm', '256', 1),
    'ymm10': ('ymm10', 'ymm', '256', 2),
    'ymm11': ('ymm11', 'ymm', '256', 3),
    'ymm12': ('ymm12', 'ymm', '256', 4),
    'ymm13': ('ymm13', 'ymm', '256', 5),
    'ymm14': ('ymm14', 'ymm', '256', 6),
    'ymm15': ('ymm15', 'ymm', '256', 7),

    'xmm16': ('xmm16', 'xmm', '128', 0),
    'xmm17': ('xmm17', 'xmm', '128', 1),
    'xmm18': ('xmm18', 'xmm', '128', 2),
    'xmm19': ('xmm19', 'xmm', '128', 3),
    'xmm20': ('xmm20', 'xmm', '128', 4),
    'xmm21': ('xmm21', 'xmm', '128', 5),
    'xmm22': ('xmm22', 'xmm', '128', 6),
    'xmm23': ('xmm23', 'xmm', '128', 7),
    'xmm24': ('xmm24', 'xmm', '128', 0),
    'xmm25': ('xmm25', 'xmm', '128', 1),
    'xmm26': ('xmm26', 'xmm', '128', 2),
    'xmm27': ('xmm27', 'xmm', '128', 3),
    'xmm28': ('xmm28', 'xmm', '128', 4),
    'xmm29': ('xmm29', 'xmm', '128', 5),
    'xmm30': ('xmm30', 'xmm', '128', 6),
    'xmm31': ('xmm31', 'xmm', '128', 7),

    'ymm16': ('ymm16', 'ymm', '256', 0),
    'ymm17': ('ymm17', 'ymm', '256', 1),
    'ymm18': ('ymm18', 'ymm', '256', 2),
    'ymm19': ('ymm18', 'ymm', '256', 3),
    'ymm20': ('ymm20', 'ymm', '256', 4),
    'ymm21': ('ymm21', 'ymm', '256', 5),
    'ymm22': ('ymm22', 'ymm', '256', 6),
    'ymm23': ('ymm23', 'ymm', '256', 7),
    'ymm24': ('ymm24', 'ymm', '256', 0),
    'ymm25': ('ymm25', 'ymm', '256', 1),
    'ymm26': ('ymm26', 'ymm', '256', 2),
    'ymm27': ('ymm27', 'ymm', '256', 3),
    'ymm28': ('ymm28', 'ymm', '256', 4),
    'ymm29': ('ymm29', 'ymm', '256', 5),
    'ymm30': ('ymm30', 'ymm', '256', 6),
    'ymm31': ('ymm31', 'ymm', '256', 7),

    'zmm0': ('zmm0', 'zmm', '512', 0),
    'zmm1': ('zmm1', 'zmm', '512', 1),
    'zmm2': ('zmm2', 'zmm', '512', 2),
    'zmm3': ('zmm3', 'zmm', '512', 3),
    'zmm4': ('zmm4', 'zmm', '512', 4),
    'zmm5': ('zmm5', 'zmm', '512', 5),
    'zmm6': ('zmm6', 'zmm', '512', 6),
    'zmm7': ('zmm7', 'zmm', '512', 7),
    'zmm8': ('zmm8', 'zmm', '512', 0),
    'zmm9': ('zmm9', 'zmm', '512', 1),
    'zmm10': ('zmm10', 'zmm', '512', 2),
    'zmm11': ('zmm11', 'zmm', '512', 3),
    'zmm12': ('zmm12', 'zmm', '512', 4),
    'zmm13': ('zmm13', 'zmm', '512', 5),
    'zmm14': ('zmm14', 'zmm', '512', 6),
    'zmm15': ('zmm15', 'zmm', '512', 7),

    'zmm16': ('zmm16', 'zmm', '512', 0),
    'zmm17': ('zmm17', 'zmm', '512', 1),
    'zmm18': ('zmm18', 'zmm', '512', 2),
    'zmm19': ('zmm18', 'zmm', '512', 3),
    'zmm20': ('zmm20', 'zmm', '512', 4),
    'zmm21': ('zmm21', 'zmm', '512', 5),
    'zmm22': ('zmm22', 'zmm', '512', 6),
    'zmm23': ('zmm23', 'zmm', '512', 7),
    'zmm24': ('zmm24', 'zmm', '512', 0),
    'zmm25': ('zmm25', 'zmm', '512', 1),
    'zmm26': ('zmm26', 'zmm', '512', 2),
    'zmm27': ('zmm27', 'zmm', '512', 3),
    'zmm28': ('zmm28', 'zmm', '512', 4),
    'zmm29': ('zmm29', 'zmm', '512', 5),
    'zmm30': ('zmm30', 'zmm', '512', 6),
    'zmm31': ('zmm31', 'zmm', '512', 7),

    'k0': ('k0', 'k64', '64', 0),
    'k1': ('k1', 'k64', '64', 1),
    'k2': ('k2', 'k64', '64', 2),
    'k3': ('k3', 'k64', '64', 3),
    'k4': ('k4', 'k64', '64', 4),
    'k5': ('k5', 'k64', '64', 5),
    'k6': ('k6', 'k64', '64', 6),
    'k7': ('k7', 'k64', '64', 7),
}


# new registers in 64-bit mode
registers_64bit = {
    # TODO - Test spl, bpl, sil and dil encoding (here only regs that require high bit are placed)
    'spl': ('spl', 'r8', '8', 4),
    'bpl': ('bpl', 'r8', '8', 5),
    'sil': ('sil', 'r8', '8', 6),
    'dil': ('dil', 'r8', '8', 7),

    'r8l': ('r8l', 'r8', '8', 0),
    'r9l': ('r9l', 'r8', '8', 1),
    'r10l': ('r10l', 'r8', '8', 2),
    'r11l': ('r11l', 'r8', '8', 3),
    'r12l': ('r12l', 'r8', '8', 4),
    'r13l': ('r13l', 'r8', '8', 5),
    'r14l': ('r14l', 'r8', '8', 6),
    'r15l': ('r15l', 'r8', '8', 7),
    'r8w': ('r8w', 'r16', '16', 0),
    'r9w': ('r9w', 'r16', '16', 1),
    'r10w': ('r10w', 'r16', '16', 2),
    'r11w': ('r11w', 'r16', '16', 3),
    'r12w': ('r12w', 'r16', '16', 4),
    'r13w': ('r13w', 'r16', '16', 5),
    'r14w': ('r14w', 'r16', '16', 6),
    'r15w': ('r15w', 'r16', '16', 7),
    'r8d': ('r8d', 'r32', '32', 0),
    'r9d': ('r9d', 'r32', '32', 1),
    'r10d': ('r10d', 'r32', '32', 2),
    'r11d': ('r11d', 'r32', '32', 3),
    'r12d': ('r12d', 'r32', '32', 4),
    'r13d': ('r13d', 'r32', '32', 5),
    'r14d': ('r14d', 'r32', '32', 6),
    'r15d': ('r15d', 'r32', '32', 7),
    'r8': ('r8', 'r64', '64', 0),
    'r9': ('r9', 'r64', '64', 1),
    'r10': ('r10', 'r64', '64', 2),
    'r11': ('r11', 'r64', '64', 3),
    'r12': ('r12', 'r64', '64', 4),
    'r13': ('r13', 'r64', '64', 5),
    'r14': ('r14', 'r64', '64', 6),
    'r15': ('r15', 'r64', '64', 7),
    'xmm8': ('xmm8', 'r128', '128', 0),
    'xmm9': ('xmm9', 'r128', '128', 1),
    'xmm10': ('xmm10', 'r128', '128', 2),
    'xmm11': ('xmm11', 'r128', '128', 3),
    'xmm12': ('xmm12', 'r128', '128', 4),
    'xmm13': ('xmm13', 'r128', '128', 5),
    'xmm14': ('xmm14', 'r128', '128', 6),
    'xmm15': ('xmm15', 'r128', '128', 7),
    'ymm8': ('ymm8', 'r256', '256', 0),
    'ymm9': ('ymm9', 'r256', '256', 1),
    'ymm10': ('ymm10', 'r256', '256', 2),
    'ymm11': ('ymm11', 'r256', '256', 3),
    'ymm12': ('ymm12', 'r256', '256', 4),
    'ymm13': ('ymm13', 'r256', '256', 5),
    'ymm14': ('ymm14', 'r256', '256', 6),
    'ymm15': ('ymm15', 'r256', '256', 7),
    'zmm8': ('ymm8', 'r256', '256', 0),
    'zmm9': ('ymm9', 'r256', '256', 1),
    'zmm10': ('ymm10', 'r256', '256', 2),
    'zmm11': ('ymm11', 'r256', '256', 3),
    'zmm12': ('ymm12', 'r256', '256', 4),
    'zmm13': ('ymm13', 'r256', '256', 5),
    'zmm14': ('ymm14', 'r256', '256', 6),
    'zmm15': ('ymm15', 'r256', '256', 7)
}

# new registers for avx-512 mode
registers_avx512 = {
    'xmm16': ('xmm16', 'xmm', '128', 0),
    'xmm17': ('xmm17', 'xmm', '128', 1),
    'xmm18': ('xmm18', 'xmm', '128', 2),
    'xmm19': ('xmm19', 'xmm', '128', 3),
    'xmm20': ('xmm20', 'xmm', '128', 4),
    'xmm21': ('xmm21', 'xmm', '128', 5),
    'xmm22': ('xmm22', 'xmm', '128', 6),
    'xmm23': ('xmm23', 'xmm', '128', 7),
    'xmm24': ('xmm24', 'xmm', '128', 8),
    'xmm25': ('xmm25', 'xmm', '128', 9),
    'xmm26': ('xmm26', 'xmm', '128', 10),
    'xmm27': ('xmm27', 'xmm', '128', 11),
    'xmm28': ('xmm28', 'xmm', '128', 12),
    'xmm29': ('xmm29', 'xmm', '128', 13),
    'xmm30': ('xmm30', 'xmm', '128', 14),
    'xmm31': ('xmm31', 'xmm', '128', 15),

    'ymm16': ('ymm16', 'ymm', '256', 0),
    'ymm17': ('ymm17', 'ymm', '256', 1),
    'ymm18': ('ymm18', 'ymm', '256', 2),
    'ymm19': ('ymm18', 'ymm', '256', 3),
    'ymm20': ('ymm20', 'ymm', '256', 4),
    'ymm21': ('ymm21', 'ymm', '256', 5),
    'ymm22': ('ymm22', 'ymm', '256', 6),
    'ymm23': ('ymm23', 'ymm', '256', 7),
    'ymm24': ('ymm24', 'ymm', '256', 8),
    'ymm25': ('ymm25', 'ymm', '256', 9),
    'ymm26': ('ymm26', 'ymm', '256', 10),
    'ymm27': ('ymm27', 'ymm', '256', 11),
    'ymm28': ('ymm28', 'ymm', '256', 12),
    'ymm29': ('ymm29', 'ymm', '256', 13),
    'ymm30': ('ymm30', 'ymm', '256', 14),
    'ymm31': ('ymm31', 'ymm', '256', 15),

    'zmm16': ('zmm16', 'zmm', '512', 0),
    'zmm17': ('zmm17', 'zmm', '512', 1),
    'zmm18': ('zmm18', 'zmm', '512', 2),
    'zmm19': ('zmm18', 'zmm', '512', 3),
    'zmm20': ('zmm20', 'zmm', '512', 4),
    'zmm21': ('zmm21', 'zmm', '512', 5),
    'zmm22': ('zmm22', 'zmm', '512', 6),
    'zmm23': ('zmm23', 'zmm', '512', 7),
    'zmm24': ('zmm24', 'zmm', '512', 8),
    'zmm25': ('zmm25', 'zmm', '512', 9),
    'zmm26': ('zmm26', 'zmm', '512', 10),
    'zmm27': ('zmm27', 'zmm', '512', 11),
    'zmm28': ('zmm28', 'zmm', '512', 12),
    'zmm29': ('zmm29', 'zmm', '512', 13),
    'zmm30': ('zmm30', 'zmm', '512', 14),
    'zmm31': ('zmm31', 'zmm', '512', 15),
}
